//------------------------------------------------------------------------
//
//  editbar.prg
//
//  Toolbar with rowset editing tool buttons.
//  To use:
/* 
     DO editbar.prg WITH f       // for small tool buttons
     DO editbar.prg WITH f, true // for large tool buttons
*/
//           do regbar.prg with this
///------------------------------------------------------------------------  

   parameter FormObj, bLarge
   local t, bNew
   t    = null
   bNew = false
   if ( PCOUNT() == 0 )
      MSGBOX("To attach this toolbar to a form use: " + ;
              CHR(13) + CHR(13) + ;
             "DO " + PROGRAM() + " WITH <form reference>","Alert")
   else
      t := FindInstance("EdToolbar")
      if ( ( t == null ) or ( not FormObj.mdi ) )
         SET PROCEDURE TO (PROGRAM()) ADDITIVE
         t = new EdToolbar( bLarge )
         bNew := true
      endif
      t.attach( FormObj )  
   endif

return ( bNew )

class EdToolbar( bLarge ) of Toolbar
   local sBitsize
   sBitsize = IIF( bLarge, "TL_", "TS_" )

   this.flat     := true
   this.text     := "Editera"
   this.onUpdate := class::edit_onUpdate

   this.tAppend = new ToolButton( this )
   with ( this.tAppend )
        bitmap   := "RESOURCE " + sBitsize + "APPEND"
        speedTip := "Ny "
        onClick  := class::tAppend_onClick
   endwith

   this.tDelete = new ToolButton( this )
   with ( this.tDelete )
        bitmap   := "RESOURCE " + sBitsize + "DELETE"
        speedTip := "Ta bort"
        onClick  := class::tDelete_onClick
   endwith
   
   this.tSave = new ToolButton( this )
   with ( this.tSave )
        bitmap   := "RESOURCE " + sBitsize + "SAVE"
        speedTip := "Spara ndringar"
        onClick  := class::tSave_onClick
   endwith

   this.tAbandon = new ToolButton( this )
   with ( this.tAbandon )
        bitmap   := "RESOURCE " + sBitsize + "ABANDON"
        speedTip := "Spara inte ndringarna"
        onClick  := class::tAbandon_onClick
   endwith

   function edit_onUpdate
      LOCAL bRowFound
      bRowFound = ( TYPE("this.form.query1.rowset") == "O" )
      this.tAppend.enabled  := bRowFound
      this.tDelete.enabled  := bRowFound
      this.tSave.enabled    := bRowFound
      this.tAbandon.enabled := bRowFound

   return ( bRowFound )

   function tAppend_onClick
*
*      this.parent.form.query1.rowset.save()
*      if this.parent.form.text = 'Vira SM'
*         vomg = this.parent.form.query1.rowset.fields["omgng"].value
*         var = this.parent.form.query1.rowset.fields["SPELR"].value
*         v1 = this.parent.form.query1.rowset.fields["vikt1"].value
*         v2 = this.parent.form.query1.rowset.fields["vikt2"].value
*      endif
*
      this.parent.form.query1.rowset.beginAppend()
*
      this.parent.form.query1.rowset.fields["speldatum"].value = date()
      this.parent.form.query1.rowset.fields["identitet"].value = 'Grund'
      this.parent.form.query1.rowset.fields["namn"].value = '???'

         qb3 = NEW QUERY()
         qb3.sql = "select namn from 'spelare.dbf' where deltar = :pD1"
         qb3.params["pD1"] = true
         qb3.active = true
         qb3.rowset.first()              
         vant = 0.00
         vant = vant + qb3.rowset.count() 
         qb3.active = false
         this.parent.form.query1.rowset.fields["ant_spelare"].value = vant 
         vp_upd_turn = true
*
      this.parent.form.query1.rowset.save()
*
   return 


   function tDelete_onClick


      local bDelete, bFirst
      bDelete = false
      bFirst  = false
      vp_id = this.parent.form.query1.rowset.fields["identitet"].value 
      vp_speldatum = this.parent.form.query1.rowset.fields["speldatum"].value 
      if ( not this.parent.form.query1.rowset.endOfSet )
         if ( MSGBOX("Du kommer att ta bort denna rad i tabellen." ;
                   + CHR(13) ;
                   + "Klicka p Ja fr borttag.", ;
                     "OBSERVERA !", ;
                     4) == 6 )

            if this.parent.form.text = 'Grunduppgifter om turneringen'

               if ( MSGBOX("Du kommer ven att ta bort alla omgngar kopplade till denna turnering." ;
                   + CHR(13) ;
                   + "Klicka p Ja fr borttag.", ;
                     "OBSERVERA !", ;
                     4+32) == 6 )


                   qb2 = NEW QUERY()
                   qb2.sql = "delete from omgang.dbf where id = :p1 and speldatum = :p2"
                   qb2.params["p1"] = vp_id
                   qb2.params["p2"] = vp_speldatum
                   qb2.active = true
                   qb2.rowset.save()
                   qb2.rowset.refresh()
                   qb2.active = false
*                  MSGBOX("Antal lag fr gruppen r minskad med 1.", "Info", 64)
                   bFirst  := this.parent.form.query1.rowset.atFirst()
                   bDelete := this.parent.form.query1.rowset.delete()       
                   if ( not bFirst ) 
                        this.parent.form.query1.rowset.next(-1)
                   endif
                   if ( this.parent.form.query1.rowset.endOfSet )
                        this.parent.form.query1.rowset.next()
                   endif

                   return
               else
                   return
               endif
            endif


            bFirst  := this.parent.form.query1.rowset.atFirst()
            bDelete := this.parent.form.query1.rowset.delete()       
            if ( not bFirst ) 
               this.parent.form.query1.rowset.next(-1)
            endif
            if ( this.parent.form.query1.rowset.endOfSet )
               this.parent.form.query1.rowset.next()
            endif


         endif
      endif
   return ( bDelete )

   function tSave_onClick

   return ( this.parent.form.query1.rowset.save() )

   function tAbandon_onClick
   return ( this.parent.form.query1.rowset.abandon() )

endclass