//------------------------------------------------------------------------
//
//  editbar.prg
//
//  Toolbar with rowset editing tool buttons.
//  To use:
/* 
     DO editbar.prg WITH f       // for small tool buttons
     DO editbar.prg WITH f, true // for large tool buttons
*/
//           do regbar.prg with this
///------------------------------------------------------------------------  

   parameter FormObj, bLarge
   local t, bNew
   t    = null
   bNew = false
   if ( PCOUNT() == 0 )
      MSGBOX("To attach this toolbar to a form use: " + ;
              CHR(13) + CHR(13) + ;
             "DO " + PROGRAM() + " WITH <form reference>","Alert")
   else
      t := FindInstance("EdToolbar")
      if ( ( t == null ) or ( not FormObj.mdi ) )
         SET PROCEDURE TO (PROGRAM()) ADDITIVE
         t = new EdToolbar( bLarge )
         bNew := true
      endif
      t.attach( FormObj )  
   endif

return ( bNew )

class EdToolbar( bLarge ) of Toolbar
   local sBitsize
   sBitsize = IIF( bLarge, "TL_", "TS_" )

   this.flat     := true
   this.text     := "Editera"
   this.onUpdate := class::edit_onUpdate

   this.tAppend = new ToolButton( this )
   with ( this.tAppend )
        bitmap   := "RESOURCE " + sBitsize + "APPEND"
        speedTip := "Ny "
        onClick  := class::tAppend_onClick
   endwith

   this.tDelete = new ToolButton( this )
   with ( this.tDelete )
        bitmap   := "RESOURCE " + sBitsize + "DELETE"
        speedTip := "Ta bort"
        onClick  := class::tDelete_onClick
   endwith
   
   this.tSave = new ToolButton( this )
   with ( this.tSave )
        bitmap   := "RESOURCE " + sBitsize + "SAVE"
        speedTip := "Spara ndringar"
        onClick  := class::tSave_onClick
   endwith

   this.tAbandon = new ToolButton( this )
   with ( this.tAbandon )
        bitmap   := "RESOURCE " + sBitsize + "ABANDON"
        speedTip := "Spara inte ndringarna"
        onClick  := class::tAbandon_onClick
   endwith

   function edit_onUpdate
      LOCAL bRowFound
      bRowFound = ( TYPE("this.form.query1.rowset") == "O" )
      this.tAppend.enabled  := bRowFound
      this.tDelete.enabled  := bRowFound
      this.tSave.enabled    := bRowFound
      this.tAbandon.enabled := bRowFound

   return ( bRowFound )

   function tAppend_onClick
*
      this.parent.form.query1.rowset.beginAppend()
*      this.parent.form.query1.rowset.fields["sqlfraga"].value = '???'

*
      this.parent.form.query1.rowset.save()
*
   return 


   function tDelete_onClick


      local bDelete, bFirst
      bDelete = false
      bFirst  = false
      if ( not this.parent.form.query1.rowset.endOfSet )
         if ( MSGBOX("Du kommer att ta bort denna rad i tabellen." ;
                   + CHR(13) ;
                   + "Klicka p Ja fr borttag.", ;
                     "OBSERVERA !", ;
                     4) == 6 )


            bFirst  := this.parent.form.query1.rowset.atFirst()
            bDelete := this.parent.form.query1.rowset.delete()       
            if ( not bFirst ) 
               this.parent.form.query1.rowset.next(-1)
            endif
            if ( this.parent.form.query1.rowset.endOfSet )
               this.parent.form.query1.rowset.next()
            endif


         endif
      endif
   return ( bDelete )



   function tSave_onClick

   return ( this.parent.form.query1.rowset.save() )



   function tAbandon_onClick
   return ( this.parent.form.query1.rowset.abandon() )

endclass