//------------------------------------------------------------------------
//
//  vcrbar.prg
//
//  Toolbar with VCR style rowset navigation tool buttons.
//  To use:
/* 
     f = new FishBarsForm()     // a form with a defined rowset
     DO vcrbar.prg WITH f       // for small tool buttons
     DO vcrbar.prg WITH f, true // for large tool buttons
*/
//  
//------------------------------------------------------------------------  

   parameter FormObj, bLarge
   local t, bNew
   t    = null
   bNew = false

   if ( PCOUNT() == 0 )
      MSGBOX("To attach this toolbar to a form use: " + ;
              CHR(13) + CHR(13) + ;
             "DO " + PROGRAM() + " WITH <form reference>","Alert")
   else
      t := FindInstance("VcrToolbar")
      if ( ( t == null ) or  ( not FormObj.mdi ) )
         SET PROCEDURE TO (PROGRAM()) ADDITIVE
         t = new VcrToolbar( bLarge )
         bNew := true
      endif
      t.attach( FormObj ) 
   endif

return ( bNew )

class VcrToolbar( bLarge ) of Toolbar
   local sBitsize
   sBitsize = IIF( bLarge, "TL_", "TS_" )

   this.flat     := true
   this.text     := "Blddra"
   this.onUpdate := class::vcr_onUpdate

   this.tFirst = new ToolButton( this )
   with ( this.tFirst )
        bitmap   := "RESOURCE " + sBitsize + "FIRST"
        speedTip := "Till brjan"
        onClick  := class::tFirst_onClick
   endwith

   this.tPrev = new ToolButton( this )
   with ( this.tPrev )
        bitmap   := "RESOURCE " + sBitsize + "PREV"
        speedTip := "Fregende"
        onClick  := class::tPrev_onClick
   endwith
   
   this.tNext = new ToolButton( this )
   with ( this.tNext )
        bitmap   := "RESOURCE " + sBitsize + "NEXT"
        speedTip := "Nsta"
        onClick  := class::tNext_onClick
   endwith

   this.tLast = new ToolButton( this )
   with ( this.tLast )
        bitmap   := "RESOURCE " + sBitsize + "LAST"
        speedTip := "Till slutet"
        onClick  := class::tLast_onClick
   endwith
* 
* -------------------------------------------------------------
* -------------------------------------------------------------
*
   function vcr_onUpdate
      local bAtFirst, bAtLast, bRowset
      bRowset = ( TYPE("this.form.query1.rowset") == "O" )
      if ( bRowset )
         bAtFirst = this.form.query1.rowset.atFirst()
         bAtLast  = this.form.query1.rowset.atLast() 
         with ( this )
            tFirst.enabled := ( NOT bAtFirst )
            tPrev.enabled  := ( NOT bAtFirst )
            tNext.enabled  := ( NOT bAtLast )
            tLast.enabled  := ( NOT bAtLast )
         endwith
      else
         with ( this )
            tFirst.enabled := false
            tPrev.enabled  := false
            tNext.enabled  := false
            tLast.enabled  := false
         endwith
      endif

*     if this.form.text = 'Copyright Stockholm Wirasllskap '
*     endif


               
   return ( bRowset )


* -----------------------------------------------------------------
* ----------------------tFirst_onClick-----------------------------
* -----------------------------------------------------------------

   function tFirst_onClick
      local bfirst

      if this.parent.form.text = 'Copyright Stockholm Wirasllskap '
         return
      endif


      bfirst = this.parent.form.query1.rowset.first()
     

   return ( bfirst )

* -----------------------------------------------------------------
* ----------------------tPrev_onClick-----------------------------
* -----------------------------------------------------------------

   function tPrev_onClick
      local bPrev

      if this.parent.form.text = 'Copyright Stockholm Wirasllskap '
         return
      endif


      bPrev = this.parent.form.query1.rowset.next(-1)
      if ( not bPrev )
         this.parent.form.query1.rowset.next()
      endif


   return ( bPrev )

* -----------------------------------------------------------------
* ----------------------tNext_onClick-----------------------------
* -----------------------------------------------------------------

   function tNext_onClick
      local bNext

      if this.parent.form.text = 'Copyright Stockholm Wirasllskap '
         return
      endif

      bNext = this.parent.form.query1.rowset.next()
      if ( not bNext )
         this.parent.form.query1.rowset.next(-1)
      endif



   return ( bNext )



   function tLast_onClick
    local blast

      if this.parent.form.text = 'Copyright Stockholm Wirasllskap '
         return
      endif


    blast = this.parent.form.query1.rowset.last()


   return ( blast )

endclass